VirtualBox

source: vbox/trunk/configure@ 73003

Last change on this file since 73003 was 72795, checked in by vboxsync, 6 years ago

configure: remove mkisofs, which we no longer use.
bugref:9200: Infrastructure/Linux: need an openSUSE 15 chroot
Neither trunk nor 5.2 need mkisofs, so remove it from configure rather than
adding it to the openSUSE 15 chroot.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 76.2 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2017 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, grep, sed to work)
23PATH="/usr/xpg4/bin:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 netbsd)
55 ;;
56 sunos)
57 OS='solaris'
58 ;;
59 haiku)
60 ;;
61 *)
62 echo "Cannot determine OS!"
63 exit 1
64 ;;
65esac
66
67#
68# Defaults
69#
70OSE=1
71ODIR="`pwd`/"
72ODIR_OVERRIDE=0
73OUT_PATH=""
74OUT_PATH_OVERRIDE=0
75SETUP_WINE=
76ONLY_ADDITIONS=0
77TARGET_MACHINE=""
78TARGET_CPU=""
79WITH_XPCOM=1
80WITH_PYTHON=1
81WITH_JAVA=1
82WITH_VMMRAW=1
83WITH_LIBIDL=1
84WITH_GSOAP=0
85WITH_QT5=1
86WITH_SDL=1
87WITH_SDL_TTF=1
88WITH_X11=1
89WITH_ALSA=1
90WITH_PULSE=1
91WITH_DBUS=1
92WITH_DEVMAPPER=1
93WITH_KMODS=1
94WITH_OPENGL=1
95WITH_HARDENING=1
96WITH_UDPTUNNEL=1
97WITH_VDE=0
98WITH_VNC=0
99WITH_EXTPACK=1
100WITH_DOCS=1
101WITH_LIBVPX=1
102BUILD_LIBXML2=
103BUILD_LIBCURL=
104BUILD_LIBSSL=
105BUILD_LIBVPX=
106PASSIVE_MESA=0
107CC="gcc"
108CC32=""
109CC64=""
110CXX="g++"
111CXX32=""
112CXX64=""
113YASM="yasm"
114IASL="iasl"
115XSLTPROC="xsltproc"
116GENISOIMAGE="genisoimage"
117INCCRYPTO=""
118LIBCRYPTO="-lssl -lcrypto"
119LIBPTHREAD="-lpthread"
120LIBCAP="-lcap"
121GSOAP=""
122GSOAP_IMPORT=""
123INCX11="/usr/local/include"
124LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
125LIBXCURSOR="-lXcursor"
126LIBXMU="-lXmu"
127LIBXINERAMA="-lXinerama"
128LIBXRANDR="-lXrandr"
129MAKESELF="makeself"
130MESA="-lGL"
131INCZ=""
132LIBZ="-lz"
133INCVNCSERVER=""
134LIBVNCSERVER="-lvncserver"
135INCDEVMAPPER=""
136LIBDEVMAPPER="-ldevmapper"
137CXX_FLAGS=""
138if [ "$OS" = "freebsd" ]; then
139 INCCURL="-I/usr/local/include"
140 LIBCURL="-L/usr/local/lib -lcurl"
141 INCPULSE="-I/usr/local/include"
142 LIBPULSE="-L/usr/local/lib"
143 INCPNG="-I/usr/local/include"
144 LIBPNG="-L/usr/local/lib -lpng"
145else
146 INCCURL=""
147 LIBCURL="-lcurl"
148 INCPNG=""
149 LIBPNG="-lpng"
150fi
151INCVPX=""
152LIBVPX="-lvpx"
153PKGCONFIG="`which_wrapper pkg-config`"
154PYTHONDIR="/usr /usr/local"
155QT5DIR="/usr/lib/qt5 /usr/share/qt5 /usr/lib64/qt5 /usr /usr/local"
156QT5DIR_PKGCONFIG=1
157QT5MAJ=5
158QT5MIN=6
159KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
160DEVDIR="`cd \`dirname $0\`; pwd`/tools"
161if [ -d "/lib/modules/`uname -r`/build" ]; then
162 LINUX="/lib/modules/`uname -r`/build"
163elif [ "`echo /lib/modules/*`" != "/lib/modules/*" ]; then
164 # Get the most recent kernel headers if none match the current kernel.
165 for i in /lib/modules/*; do
166 if [ -r "$i/build" ]; then
167 LINUX="$i/build"
168 fi
169 done
170fi
171if [ -z "$LINUX" ]; then
172 LINUX="/usr/src/linux"
173fi
174KCHMVIEWER="kchmviewer"
175LOG="configure.log"
176CNF="AutoConfig.kmk"
177ENV="env.sh"
178BUILD_TYPE="release"
179# the restricting tool is ar (mri mode).
180INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
181
182if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
183 echo "Error: VBox base path contains invalid characters!"
184 exit 1
185fi
186
187# Posix /bin/sh isn't supporting echo -n. Use printf instead.
188ECHO_N="printf"
189
190
191cleanup()
192{
193 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
194}
195
196fail()
197{
198 if [ -z "$nofatal" -o "x$1" != "x" ]; then
199 cleanup
200 rm -f $ENV
201 echo "Check $LOG for details"
202 exit 1
203 fi
204}
205
206log()
207{
208 echo "$1"
209 echo "$1" >> $LOG
210}
211
212log_success()
213{
214 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
215 echo "OK."
216 echo "$1" >> $LOG
217 echo >> $LOG
218 echo >> $LOG
219}
220
221log_failure()
222{
223 echo
224 echo " ** $1!"
225 echo "** $1!" >> $LOG
226 echo >> $LOG
227}
228
229cnf_append()
230{
231 printf "%-30s := %s\n" "$1" "$2" >> $CNF
232}
233
234strip_l()
235{
236 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
237}
238
239strip_L()
240{
241 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
242}
243
244strip_I()
245{
246 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
247}
248
249prefix_I()
250{
251 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
252}
253
254check_avail()
255{
256 if [ -z "$1" ]; then
257 log_failure "$2 is empty"
258 fail $3
259 return 1
260 elif which_wrapper $1 > /dev/null; then
261 return 0
262 else
263 log_failure "$1 (variable $2) not found"
264 fail $3
265 return 1
266 fi
267}
268
269
270# Prepare a test
271test_header()
272{
273 echo "***** Checking $1 *****" >> $LOG
274 $ECHO_N "Checking for $1: "
275}
276
277
278# Compile a test
279# $1 compile flags/libs
280# $2 library name
281# $3 package name
282# $4 if this argument is 'nofatal', don't abort
283test_compile()
284{
285 echo "compiling the following source file:" >> $LOG
286 cat $ODIR.tmp_src.cc >> $LOG
287 echo "using the following command line:" >> $LOG
288 echo "$CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
289 $CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
290 if [ $? -ne 0 ]; then
291 if [ -z "$4" ]; then
292 echo
293 echo " $2 not found at $1 or $3 headers not found"
294 echo " Check the file $LOG for detailed error information."
295 fail
296 else
297 echo >> $LOG
298 echo >> $LOG
299 fi
300 return 1
301 fi
302 return 0
303}
304
305
306# Execute a compiled test binary
307test_execute()
308{
309 echo "executing the binary" >> $LOG
310 $ODIR.tmp_out > $ODIR.test_execute.log
311 rc=$?
312 cat $ODIR.test_execute.log | tee -a $LOG
313 if [ $rc -ne 0 ]; then
314 fail $1
315 return 1
316 fi
317 echo >> $LOG
318 echo >> $LOG
319 return 0
320}
321
322
323# Execute a compiled test binary
324test_execute_path()
325{
326 ## LD_LIBRARY_PATH to set.
327 local_path="${1}"
328 ## Set this to non-empty to make this test non-fatal.
329 local_nofail="${2}"
330 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
331 LD_LIBRARY_PATH="${local_path}" $ODIR.tmp_out > $ODIR.test_execute.log
332 rc=$?
333 cat $ODIR.test_execute.log | tee -a $LOG
334 if [ $rc -ne 0 ]; then
335 test -z "${local_nofail}" && fail
336 echo >> $LOG
337 echo >> $LOG
338 return 1
339 fi
340 echo >> $LOG
341 echo >> $LOG
342 return 0
343}
344
345
346#
347# Check for OS, MACHINE, CPU
348#
349check_environment()
350{
351 test_header environment
352 BUILD_CPU=`uname -m`
353 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
354 case "$BUILD_CPU" in
355 i[3456789]86|x86|i86pc|BePC)
356 BUILD_MACHINE='x86'
357 LIB='lib'
358 ;;
359 x86_64|amd64)
360 BUILD_MACHINE='amd64'
361 BUILD_CPU='k8'
362 if [ "$OS" != "solaris" ]; then
363 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
364 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
365 LIB='lib64'
366 else
367 # Solaris doesn't seem to subscribe to fhs, libs are usually in
368 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
369 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
370 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
371 # have to make sure the */bin/amd64 dirs are searched before the */bin
372 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
373 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
374 echo "old PATH: $PATH" >> $LOG
375 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
376 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
377 export PATH
378 echo "new PATH: $PATH" >> $LOG
379 LIB='lib/64'
380 fi
381 ;;
382 sparc64|sparcv9)
383 BUILD_MACHINE='sparc64'
384 BUILD_CPU='blend'
385 ;;
386 sparc32|sparc|sparcv8|sparcv7|sparcv8e)
387 BUILD_MACHINE='sparc32'
388 BUILD_CPU='blend'
389 ;;
390 *)
391 log_failure "Cannot determine system"
392 exit 1
393 ;;
394 esac
395 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
396 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
397 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
398 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
399
400 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
401 echo "export BUILD_PLATFORM" >> $ENV
402 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
403 echo "export BUILD_PLATFORM_ARCH" >> $ENV
404 echo "BUILD_TARGET=\"$OS\"" >> $ENV
405 echo "export BUILD_TARGET" >> $ENV
406 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
407 echo "export BUILD_TARGET_ARCH" >> $ENV
408 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
409 echo "export BUILD_TARGET_CPU" >> $ENV
410 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
411 echo "export BUILD_TYPE" >> $ENV
412}
413
414#
415# Check for gcc with version >= 3.2.
416# We depend on a working gcc, if we fail terminate in every case.
417#
418check_gcc()
419{
420 test_header gcc
421 if check_avail "$CC" CC really; then
422 cc_ver=`$CC -dumpfullversion 2>/dev/null`
423 if [ $? -ne 0 ]; then
424 cc_ver=`$CC -dumpversion 2>/dev/null`
425 fi
426 if [ $? -ne 0 ]; then
427 log_failure "cannot execute '$CC -dumpversion'"
428 fail really
429 fi
430 if check_avail "$CXX" CXX really; then
431 cxx_ver=`$CXX -dumpfullversion 2>/dev/null`
432 if [ $? -ne 0 ]; then
433 cxx_ver=`$CXX -dumpversion 2>/dev/null`
434 fi
435 if [ $? -ne 0 ]; then
436 log_failure "cannot execute '$CXX -dumpversion'"
437 fail really
438 fi
439 cc_maj=`echo $cc_ver|cut -d. -f1`
440 cc_min=`echo $cc_ver|cut -d. -f2`
441 if [ "x$cc_ver" != "x$cxx_ver" ]; then
442 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
443 fail really
444 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
445 log_success "found version $cc_ver"
446 # gcc-4.0 is allowed for Darwin only
447 elif [ $cc_maj -lt 4 \
448 -o \( $cc_maj -eq 4 -a $cc_min -lt 4 -a "$OS" != "darwin" \) \
449 -o \( $cc_maj -eq 4 -a $cc_min -lt 2 -a "$OS" = "darwin" \) \
450 -o $cc_maj -gt 7 ]; then
451 log_failure "gcc version $cc_maj.$cc_min found, expected gcc 4.x...7.x"
452 fail really
453 else
454 log_success "found version $cc_ver"
455 fi
456 if [ "$BUILD_MACHINE" = "amd64" ]; then
457 [ -z "$CC32" ] && CC32="$CC -m32"
458 [ -z "$CXX32" ] && CXX32="$CXX -m32"
459 else
460 [ -z "$CC32" ] && CC32="$CC"
461 [ -z "$CXX32" ] && CXX32="$CXX"
462 fi
463 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
464 [ -z "$CC64" ] && CC64="$CC -m64"
465 [ -z "$CXX64" ] && CXX64="$CXX -m64"
466 fi
467 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
468 CC32="undefined"
469 CXX32="undefined"
470 fi
471 if [ "$CC" != "gcc" ]; then
472 cnf_append "TOOL_GCC3_CC" "$CC"
473 cnf_append "TOOL_GCC3_AS" "$CC"
474 cnf_append "TOOL_GCC3_LD" "$CC"
475 cnf_append "TOOL_GXX3_CC" "$CC"
476 cnf_append "TOOL_GXX3_AS" "$CC"
477 fi
478 if [ "$CXX" != "g++" ]; then
479 cnf_append "TOOL_GCC3_CXX" "$CXX"
480 cnf_append "TOOL_GXX3_CXX" "$CXX"
481 cnf_append "TOOL_GXX3_LD" "$CXX"
482 fi
483 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
484 cnf_append "TOOL_GCC32_CC" "$CC32"
485 cnf_append "TOOL_GCC32_AS" "$CC32"
486 cnf_append "TOOL_GCC32_LD" "$CC32"
487 cnf_append "TOOL_GXX32_CC" "$CC32"
488 cnf_append "TOOL_GXX32_AS" "$CC32"
489 fi
490 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
491 cnf_append "TOOL_GCC32_CXX" "$CXX32"
492 cnf_append "TOOL_GXX32_CXX" "$CXX32"
493 cnf_append "TOOL_GXX32_LD" "$CXX32"
494 fi
495 # this isn't not necessary, there is not such tool.
496 if [ -n "$CC64" ]; then
497 cnf_append "TOOL_GCC64_CC" "$CC64"
498 cnf_append "TOOL_GCC64_AS" "$CC64"
499 cnf_append "TOOL_GCC64_LD" "$CC64"
500 cnf_append "TOOL_GXX64_CC" "$CC64"
501 cnf_append "TOOL_GXX64_AS" "$CC64"
502 fi
503 if [ -n "$CXX64" ]; then
504 cnf_append "TOOL_GCC64_CXX" "$CXX64"
505 cnf_append "TOOL_GXX64_CXX" "$CXX64"
506 cnf_append "TOOL_GXX64_LD" "$CXX64"
507 fi
508 if [ "$CC" != "gcc" ]; then
509 if [ -n "$CC64" ]; then
510 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC64"
511 else
512 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC"
513 fi
514 if [ -n "$CXX64" ]; then
515 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX64"
516 else
517 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX"
518 fi
519 fi
520 # Solaris sports a 32-bit gcc/g++.
521 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
522 [ "$CC" = "gcc" ] && CC="gcc -m64"
523 [ "$CXX" = "g++" ] && CXX="g++ -m64"
524 fi
525 fi
526 fi
527}
528
529
530#
531# Check for the OpenWatcom compiler, needed for compiling the BIOS
532#
533# If the system has Open Watcom installed, WATCOM will be set in the
534# environment. If the user has her/his own Open Watcom install it will be
535# pointed to by on the command line, which will set the WATCOM variable.
536# The only exception is detecting OpenWatcom in tools/common/openwatcom.
537#
538check_open_watcom()
539{
540 test_header "Open Watcom"
541
542 if [ -z "$WATCOM" ]; then
543 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
544 if [ -z "$WATCOM" ]; then
545 if [ $OSE -eq 0 -a $OS = "linux" ]; then
546 log_failure "Open Watcom was not found"
547 exit 1
548 fi
549 log_failure "Open Watcom was not found, using alternative BIOS sources"
550 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
551 return 0;
552 fi
553 fi
554
555 case "$OS" in
556 "darwin") wc_bin="binosx";; # ??
557 "dos") wc_bin="binw";;
558 "freebsd") wc_bin="binfbsd";; # ??
559 "linux") wc_bin="binl";;
560 "netbsd") wc_bin="binnbsd";; # ??
561 "solaris") wc_bin="binsol";; # ??
562 "os2") wc_bin="binp";;
563 "win") wc_bin="binnt";;
564 *) wc_bin="binl";;
565 esac
566
567 # Check that the tools we use are there.
568 for prog in wasm wcc wlink;
569 do
570 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
571 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
572 fail
573 fi
574 done
575
576 # Use WASM to get the version.
577 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
578 if [ -z "$wasm_ver" ]; then
579 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
580 fail
581 fi
582 log_success "found version $wasm_ver"
583 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
584 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
585
586 unset wasm_ver
587 unset wc_wasm
588 unset wc_bin
589}
590
591
592#
593# Check for yasm, needed to compile assembler files
594#
595check_yasm()
596{
597 test_header yasm
598 if check_avail "$YASM" YASM; then
599 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
600 if [ $? -ne 0 ]; then
601 log_failure "yasm not found"
602 fail
603 else
604 yasm_maj=`echo $yasm_ver|cut -d. -f1`
605 yasm_min=`echo $yasm_ver|cut -d. -f2`
606 yasm_rev=`echo $yasm_ver|cut -d. -f3`
607 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
608 if [ $yasm_ver_mul -lt 501 ]; then
609 log_failure "found version $yasm_ver, expected at least 0.5.1"
610 fail
611 else
612 log_success "found version $yasm_ver"
613 fi
614 fi
615 fi
616}
617
618
619#
620# Check for the iasl ACPI compiler, needed to compile vbox.dsl
621#
622check_iasl()
623{
624 test_header iasl
625 if check_avail "$IASL" IASL; then
626 iasl_ver=`$IASL|grep "ASL.*version"|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
627 if [ $? -ne 0 ]; then
628 log_failure "iasl not found"
629 fail
630 else
631 log_success "found version $iasl_ver"
632 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
633 fi
634 fi
635}
636
637
638#
639# Check for xsltproc, needed by Main
640#
641check_xsltproc()
642{
643 if [ -n "$BUILD_LIBXSLT" ]; then
644 return 0;
645 fi
646 test_header xslt
647 if check_avail "$XSLTPROC" XSLTPROC; then
648 xsltproc_ver=`$XSLTPROC --version`
649 if [ $? -ne 0 ]; then
650 log_failure "xsltproc not found"
651 fail
652 else
653 log_success "found"
654 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
655 fi
656 fi
657}
658
659
660#
661# Check for libxml2, needed by VBoxSettings and Runtime.
662# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
663#
664check_libxml2()
665{
666 if [ -z "$BUILD_LIBXML2" ]; then
667 test_header libxml2
668 if which_wrapper pkg-config > /dev/null; then
669 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
670 if [ $? -ne 0 ]; then
671 log_failure "libxml2 not found"
672 fail
673 else
674 FLGXML2=`pkg-config libxml-2.0 --cflags`
675 INCXML2=`strip_I "$FLGXML2"`
676 LIBXML2=`pkg-config libxml-2.0 --libs`
677 cat > $ODIR.tmp_src.cc << EOF
678#include <cstdio>
679#include <libxml/xmlversion.h>
680extern "C" int main(void)
681{
682 printf("found version %s", LIBXML_DOTTED_VERSION);
683#if LIBXML_VERSION >= 20626
684 printf(", OK.\n");
685 return 0;
686#else
687 printf(", expected version 2.6.26 or higher\n");
688 return 1;
689#endif
690}
691EOF
692 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
693 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
694 if test_execute; then
695 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
696 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
697 fi
698 fi
699 fi
700 elif which_wrapper xml2-config; then
701 libxml2_ver=`xml2-config --version`
702 if [ $? -ne 0 ]; then
703 log_failure "xml2-config not found"
704 fail
705 else
706 log_success "found version $libxml2_ver"
707 FLGXML2=`xml2-config --cflags`
708 INCXML2=`strip_I "$FLGXML2"`
709 LIBXML2=`xml2-config --libs`
710 cat > $ODIR.tmp_src.cc << EOF
711#include <cstdio>
712#include <libxml/xmlversion.h>
713extern "C" int main(void)
714{
715 printf("found version %s", LIBXML_DOTTED_VERSION);
716#if LIBXML_VERSION >= 20626
717 printf(", OK.\n");
718 return 0;
719#else
720 printf(", expected version 2.6.26 or higher\n");
721 return 1;
722#endif
723}
724EOF
725 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
726 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
727 if test_execute; then
728 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
729 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
730 fi
731 fi
732 fi
733 else
734 log_failure "neither pkg-config nor xml2-config found"
735 fail
736 fi
737 fi
738}
739
740
741#
742# Check for libIDL, needed by xpcom
743#
744check_libidl()
745{
746 test_header libIDL
747
748 if which_wrapper libIDL-config-2 > /dev/null; then
749 libidl_ver=`libIDL-config-2 --version`
750 if [ $? -ne 0 ]; then
751 log_failure "libIDL-config-2 not working"
752 fail
753 else
754 log_success "found version $libidl_ver"
755 cnf_append "VBOX_LIBIDL_CONFIG" \
756 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
757 fi
758 elif check_avail "libIDL-config" libIDL-config; then
759 libidl_ver=`libIDL-config --version`
760 if [ $? -ne 0 ]; then
761 log_failure "libIDL-config not working"
762 fail
763 else
764 log_success "found version $libidl_ver"
765 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
766 fi
767 fi
768}
769
770
771#
772# Check for libdevmapper, needed by the VBoxVolInfo
773#
774check_libdevmapper()
775{
776 test_header libdevmapper
777 cat > $ODIR.tmp_src.cc << EOF
778#include <cstdio>
779extern "C" {
780#define private
781#include <libdevmapper.h>
782int main()
783{
784 char version[80];
785
786 if (!dm_get_library_version(version, sizeof(version)))
787 {
788 printf("dm_get_library_version() failed.\n");
789 return 1;
790 }
791
792 const char* v=version;
793 unsigned int major = 0, minor = 0, micro = 0;
794
795 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
796 if (*v == '.') v++;
797 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
798 if (*v == '.') v++;
799 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
800
801 printf("found version %s", version);
802 if (major*10000 + minor*100 + micro >= 10200)
803 {
804 printf(", OK.\n");
805 return 0;
806 }
807 else
808 {
809 printf(", expected version 1.02 or higher\n");
810 return 1;
811 }
812}
813}
814EOF
815 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
816 if test_execute; then
817 cnf_append "VBOX_WITH_DEVMAPPER" "1"
818 fi
819 fi
820}
821
822
823#
824# Check for openssl, needed for RDP and S3
825#
826check_ssl()
827{
828 if [ -z "$BUILD_LIBSSL" ]; then
829 test_header ssl
830 cat > $ODIR.tmp_src.cc << EOF
831#include <cstdio>
832#include <openssl/opensslv.h>
833#include <openssl/ssl.h>
834extern "C" int main(void)
835{
836 printf("found version %s", OPENSSL_VERSION_TEXT);
837 SSL_library_init();
838#if OPENSSL_VERSION_NUMBER >= 0x00908000
839 printf(", OK.\n");
840 return 0;
841#else
842 printf(", expected version 0.9.8 or higher\n");
843 return 1;
844#endif
845}
846EOF
847 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
848 if test_execute nofatal; then
849 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
850 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
851 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
852 fi
853 fi
854 fi
855}
856
857
858#
859# Check for pthread, needed by VBoxSVC, frontends, ...
860#
861check_pthread()
862{
863 test_header pthread
864 cat > $ODIR.tmp_src.cc << EOF
865#include <cstdio>
866#include <pthread.h>
867extern "C" int main(void)
868{
869 pthread_mutex_t mutex;
870 if (pthread_mutex_init(&mutex, NULL)) {
871 printf("pthread_mutex_init() failed\n");
872 return 1;
873 }
874 if (pthread_mutex_lock(&mutex)) {
875 printf("pthread_mutex_lock() failed\n");
876 return 1;
877 }
878 if (pthread_mutex_unlock(&mutex)) {
879 printf("pthread_mutex_unlock() failed\n");
880 return 1;
881 }
882 printf("found, OK.\n");
883}
884EOF
885 if test_compile $LIBPTHREAD pthread pthread; then
886 if test_execute; then
887 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
888 fi
889 fi
890}
891
892
893#
894# Check for zlib, needed by VBoxSVC, Runtime, ...
895#
896check_z()
897{
898 test_header zlib
899 cat > $ODIR.tmp_src.cc << EOF
900#include <cstdio>
901#include <zlib.h>
902extern "C" int main(void)
903{
904 printf("found version %s", ZLIB_VERSION);
905#if ZLIB_VERNUM >= 0x1210
906 printf(", OK.\n");
907 return 0;
908#else
909 printf(", expected version 1.2.1 or higher\n");
910 return 1;
911#endif
912}
913EOF
914 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
915 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
916 if test_execute; then
917 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux)" >> $CNF
918 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
919 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
920 echo "endif" >> $CNF
921 fi
922 fi
923}
924
925
926#
927# Check for libpng, needed by kchmviewer
928#
929check_png()
930{
931 test_header libpng
932 cat > $ODIR.tmp_src.cc << EOF
933#include <cstdio>
934#include <png.h>
935extern "C" int main(void)
936{
937 printf("found version %s", PNG_LIBPNG_VER_STRING);
938#if PNG_LIBPNG_VER >= 10205
939 printf(", OK.\n");
940 return 0;
941#else
942 printf(", expected version 1.2.5 or higher\n");
943 return 1;
944#endif
945}
946EOF
947 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
948 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
949 if test_execute; then
950 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
951 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
952 fi
953 fi
954}
955
956#
957# Check for libvncserver, needed for VNC in OSE
958#
959check_vncserver()
960{
961 test_header libvncserver
962 cat > $ODIR.tmp_src.cc <<EOF
963#include <cstdio>
964#include <rfb/rfbconfig.h>
965
966extern "C" int main()
967{
968 const char* v=LIBVNCSERVER_VERSION;
969 unsigned int major = 0, minor = 0, micro = 0;
970
971 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
972 if (*v == '.') v++;
973 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
974 if (*v == '.') v++;
975 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
976
977 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
978 if (major*10000 + minor*100 + micro >= 900)
979 {
980 printf(", OK.\n");
981 return 0;
982 }
983 else
984 {
985 printf(", expected version 0.9 or higher\n");
986 return 1;
987 }
988}
989EOF
990 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
991 if test_execute; then
992 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
993 fi
994 fi
995}
996
997#
998# Check for libcurl, needed by S3
999#
1000check_curl()
1001{
1002 if [ -z "$BUILD_LIBCURL" ]; then
1003 test_header libcurl
1004 cat > $ODIR.tmp_src.cc << EOF
1005#include <cstdio>
1006#include <curl/curl.h>
1007extern "C" int main(void)
1008{
1009 printf("found version %s", LIBCURL_VERSION);
1010#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
1011 printf(", OK.\n");
1012 return 0;
1013#else
1014 printf(", expected version 7.19.1 or higher\n");
1015 return 1;
1016#endif
1017}
1018EOF
1019 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1020 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1021 if test_execute; then
1022 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1023 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1024 fi
1025 fi
1026 fi
1027}
1028
1029
1030#
1031# Check for pam, needed by VRDPAuth
1032# Version 79 was introduced in 9/2005, do we support older versions?
1033# Debian/sarge uses 76
1034# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1035#
1036check_pam()
1037{
1038 test_header pam
1039 cat > $ODIR.tmp_src.cc << EOF
1040#include <cstdio>
1041#include <security/pam_appl.h>
1042extern "C" int main(void)
1043{
1044 printf("found version %d", __LIBPAM_VERSION);
1045 if (__LIBPAM_VERSION >= 76)
1046 {
1047 printf(", OK.\n");
1048 return 0;
1049 }
1050 else
1051 {
1052 printf(", expected version 76 or higher\n");
1053 return 1;
1054 }
1055}
1056EOF
1057 if test_compile "-lpam" pam pam nofatal; then
1058 if test_execute nofatal; then
1059 return 0;
1060 fi
1061 fi
1062 echo "pam0.x not found"
1063 test_header linux_pam
1064 cat > $ODIR.tmp_src.cc << EOF
1065#include <cstdio>
1066#include <security/pam_appl.h>
1067extern "C" int main(void)
1068{
1069 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1070 if (__LINUX_PAM__ >= 1)
1071 {
1072 printf(", OK.\n");
1073 return 0;
1074 }
1075 else
1076 {
1077 printf(", expected version 1.0 or higher\n");
1078 return 1;
1079 }
1080}
1081EOF
1082 if test_compile "-lpam" pam pam; then
1083 test_execute
1084 fi
1085}
1086
1087
1088#
1089# Check for the SDL library, needed by VBoxSDL and VirtualBox
1090# We depend at least on version 1.2.7
1091#
1092check_sdl()
1093{
1094 test_header SDL
1095 if [ "$OS" = "darwin" ]; then
1096 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1097 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1098 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1099 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1100 fi
1101 if [ -n "$PATH_SDK_LIBSDL" ]; then
1102 foundsdl=1
1103 INCSDL="$PATH_SDK_LIBSDL/Headers"
1104 FLDSDL="-framework SDL"
1105 else
1106 log_failure "SDL framework not found"
1107 fail
1108 fi
1109 else
1110 if which_wrapper sdl-config > /dev/null; then
1111 FLGSDL=`sdl-config --cflags`
1112 INCSDL=`strip_I "$FLGSDL"`
1113 LIBSDL=`sdl-config --libs`
1114 LIBSDLMAIN="-lSDLmain"
1115 FLDSDL=
1116 foundsdl=1
1117 fi
1118 fi
1119 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1120 if [ -n "$foundsdl" ]; then
1121 cat > $ODIR.tmp_src.cc << EOF
1122#include <cstdio>
1123#include <SDL.h>
1124#include <SDL_main.h>
1125#undef main
1126extern "C" int main(int argc, char** argv)
1127{
1128 printf("found version %d.%d.%d",
1129 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1130#if SDL_VERSION_ATLEAST(1,2,7)
1131 printf(", OK.\n");
1132 return 0;
1133#else
1134 printf(", expected version 1.2.7 or higher\n");
1135 return 1;
1136#endif
1137}
1138EOF
1139 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1140 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1141 if test_execute; then
1142 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1143 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1144 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1145 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1146 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1147 fi
1148 fi
1149 else
1150 log_failure "SDL not found (can be disabled using --disable-sdl)"
1151 fail
1152 fi
1153}
1154
1155
1156#
1157# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1158#
1159check_sdl_ttf()
1160{
1161 test_header SDL_ttf
1162 cat > $ODIR.tmp_src.cc << EOF
1163#include <cstdio>
1164#include <SDL_ttf.h>
1165#ifndef SDL_TTF_MAJOR_VERSION
1166#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1167#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1168#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1169#endif
1170extern "C" int main(void)
1171{
1172 printf("found version %d.%d.%d",
1173 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1174#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1175 printf(", OK.\n");
1176 return 0;
1177#else
1178 printf(", expected version 2.0.6 or higher\n");
1179 return 1;
1180#endif
1181}
1182EOF
1183 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1184 test_execute nofatal || \
1185 cnf_append "VBOX_WITH_SECURELABEL" ""
1186 else
1187 echo "not found -- disabling VBoxSDL secure label."
1188 cnf_append "VBOX_WITH_SECURELABEL" ""
1189 fi
1190}
1191
1192
1193#
1194# Check for libasound, needed by the ALSA audio backend
1195#
1196check_alsa()
1197{
1198 test_header ALSA
1199 cat > $ODIR.tmp_src.cc << EOF
1200#include <cstdio>
1201#include <alsa/asoundlib.h>
1202extern "C" int main(void)
1203{
1204 printf("found version %d.%d.%d",
1205 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1206#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10014
1207 printf(", OK.\n");
1208 return 0;
1209#else
1210 printf(", expected version 1.0.14 or higher\n");
1211 return 1;
1212#endif
1213}
1214EOF
1215 if test_compile "-lasound" asound asound; then
1216 test_execute
1217 fi
1218}
1219
1220
1221#
1222# Check for PulseAudio
1223#
1224check_pulse()
1225{
1226 test_header "PulseAudio"
1227 cat > $ODIR.tmp_src.cc << EOF
1228#include <cstdio>
1229#include <pulse/version.h>
1230extern "C" int main(void)
1231{
1232 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1233#if PA_API_VERSION >= 9
1234 printf(", OK.\n");
1235 return 0;
1236#else
1237 printf(", expected version 0.9.0 (API version 9) or higher\n");
1238 return 1;
1239#endif
1240}
1241EOF
1242 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1243 test_execute
1244 fi
1245}
1246
1247
1248#
1249# Check for the X libraries (Xext, X11)
1250#
1251check_x()
1252{
1253 test_header "X libraries"
1254 cat > $ODIR.tmp_src.cc << EOF
1255#include <cstdio>
1256#include <X11/Xlib.h>
1257extern "C" int main(void)
1258{
1259 Display *dpy;
1260 int scrn_num;
1261 Screen *scrn;
1262 Window win;
1263
1264 dpy = XOpenDisplay(NULL);
1265 scrn_num = DefaultScreen(dpy);
1266 scrn = ScreenOfDisplay(dpy, scrn_num);
1267 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1268 0, 16, InputOutput, CopyFromParent, 0, NULL);
1269 XDestroyWindow(dpy, win);
1270 XCloseDisplay(dpy);
1271}
1272EOF
1273 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1274 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1275 log_success "found"
1276 fi
1277}
1278
1279
1280#
1281# Check for the Xcursor library, needed by VBoxSDL.
1282#
1283check_xcursor()
1284{
1285 test_header Xcursor
1286 cat > $ODIR.tmp_src.cc << EOF
1287#include <cstdio>
1288#include <X11/Xlib.h>
1289#include <X11/Xcursor/Xcursor.h>
1290extern "C" int main(void)
1291{
1292 XcursorImage *cursor = XcursorImageCreate (10, 10);
1293 XcursorImageDestroy(cursor);
1294 return 0;
1295}
1296EOF
1297 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1298 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1299 log_success "found"
1300 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1301 fi
1302}
1303
1304
1305#
1306# Check for the Xinerama library, needed by the Qt GUI
1307#
1308check_xinerama()
1309{
1310 test_header Xinerama
1311 cat > $ODIR.tmp_src.cc << EOF
1312#include <X11/Xlib.h>
1313#include <X11/extensions/Xinerama.h>
1314extern "C" int main(void)
1315{
1316 Display *dpy;
1317 Bool flag;
1318 dpy = XOpenDisplay(NULL);
1319 if (dpy)
1320 {
1321 flag = XineramaIsActive(dpy);
1322 XCloseDisplay(dpy);
1323 }
1324}
1325EOF
1326 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1327 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1328 log_success "found"
1329 fi
1330}
1331
1332
1333#
1334# Check for the Xinerama library, needed by the Qt GUI
1335#
1336check_xrandr()
1337{
1338 test_header Xrandr
1339 cat > $ODIR.tmp_src.cc << EOF
1340#include <X11/Xlib.h>
1341#include <X11/extensions/Xrandr.h>
1342extern "C" int main(void)
1343{
1344 Display *dpy;
1345 Bool flag;
1346 int major, minor;
1347 dpy = XOpenDisplay(NULL);
1348 if (dpy)
1349 {
1350 flag = XRRQueryVersion(dpy, &major, &minor);
1351 XCloseDisplay(dpy);
1352 }
1353}
1354EOF
1355 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1356 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1357 log_success "found"
1358 fi
1359}
1360
1361
1362#
1363# Check for OpenGL
1364#
1365check_opengl()
1366{
1367 # On darwin this is a on/off decision only
1368 if [ "$OS" = "darwin" ]; then
1369 test_header "OpenGL support"
1370 echo "enabled"
1371 cnf_append "VBOX_WITH_CROGL" "1"
1372 else
1373 check_xmu
1374 check_mesa
1375 fi
1376}
1377
1378
1379#
1380# Check for the Xmu library, needed by OpenGL
1381#
1382check_xmu()
1383{
1384 test_header Xmu
1385 cat > $ODIR.tmp_src.cc << EOF
1386#include <cstdio>
1387#include <X11/Xatom.h>
1388#include <X11/Xlib.h>
1389#include <X11/Xutil.h>
1390#include <X11/Xmu/StdCmap.h>
1391extern "C" int main(void)
1392{
1393 Display *dpy;
1394 int scrn_num;
1395 Screen *scrn;
1396
1397 dpy = XOpenDisplay(NULL);
1398 if (dpy)
1399 {
1400 scrn_num = DefaultScreen(dpy);
1401 scrn = ScreenOfDisplay(dpy, scrn_num);
1402 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1403 24, XA_RGB_DEFAULT_MAP, False, True);
1404 printf("Status = %x\n", status);
1405 XCloseDisplay(dpy);
1406 }
1407 return 0;
1408}
1409EOF
1410 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1411 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1412 log_success "found"
1413 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1414 fi
1415}
1416
1417#
1418# Check for Mesa, needed by OpenGL
1419#
1420check_mesa()
1421{
1422 test_header "Mesa / GLU"
1423 cat > $ODIR.tmp_src.cc << EOF
1424#include <cstdio>
1425#include <X11/Xlib.h>
1426#include <GL/glx.h>
1427#include <GL/glu.h>
1428extern "C" int main(void)
1429{
1430 Display *dpy;
1431 int major, minor;
1432
1433 dpy = XOpenDisplay(NULL);
1434 if (dpy)
1435 {
1436 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1437 XCloseDisplay(dpy);
1438 if (glx_version)
1439 {
1440 printf("found version %u.%u, OK.\n", major, minor);
1441 return 0;
1442 }
1443 }
1444 printf("found (inactive), OK.\n");
1445 return 0;
1446}
1447EOF
1448 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1449 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1450 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1451 test_execute
1452 fi
1453}
1454
1455
1456#
1457# Check for the Qt5 library, needed by the VirtualBox frontend
1458#
1459# Currently not fatal.
1460#
1461check_qt5()
1462{
1463 foundqt5=
1464 test_header Qt5
1465 cat > $ODIR.tmp_src.cc << EOF
1466#include <QtGlobal>
1467extern "C" int main(void)
1468{
1469EOF
1470 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1471 cat >> $ODIR.tmp_src.cc << EOF
1472 return 0;
1473#else
1474 return 1;
1475#endif
1476}
1477EOF
1478 if [ "$OS" = "darwin" ]; then
1479 # First check if there is the internal version of Qt. If yes nothing else
1480 # has to be done.
1481 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1482 for t in $QT_INTERNAL; do
1483 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1484 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1485 log_success "use internal version"
1486 return
1487 fi
1488 done
1489 # Now try the user provided directory and some of the standard directories.
1490 QT_TRIES="$QT5DIR /System/Library /Library"
1491 for t in $QT_TRIES; do
1492 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1493 PATH_SDK_QT5="$t"
1494 break
1495 fi
1496 done
1497 # Add the necessary params for building the test application
1498 if [ -n "$PATH_SDK_QT5" ]; then
1499 foundqt5=1
1500 INCQT5=-I$PATH_SDK_QT5/Frameworks/QtCore.framework/Headers
1501 LIBQT5=-F$PATH_SDK_QT5/Frameworks
1502 FLGQT5="-framework QtCore"
1503 else
1504 log_failure "Qt5 framework not found (can be disabled using --disable-qt)"
1505 fail
1506 fi
1507 else # !darwin
1508 if [ $QT5DIR_PKGCONFIG -eq 1 ]; then
1509 # Default is to use pkg-config:
1510 if which_wrapper pkg-config > /dev/null; then
1511 qt5_ver=`pkg-config Qt5Core --modversion 2>> $LOG`
1512 if [ $? -eq 0 ]; then
1513 echo "(Qt5 from pkg-config)" >> $LOG
1514 FLGQT5=`pkg-config Qt5Core --cflags`
1515 # gcc 4.8 is able to compile with C++11 (see also VBOX_GCC_std in Config.kmk)
1516 [ $cc_maj -eq 4 -a $cc_min -eq 8 ] && FLGQT5="$FLGQT5 -std=c++11"
1517 INCQT5=`strip_I "$FLGQT5"`
1518 LIBDIR5=`pkg-config Qt5Core --variable=libdir`
1519 LIBQT5=`pkg-config Qt5Core --libs`
1520 LIBQT5="-L$LIBDIR5 $LIBQT5"
1521 TOOLQT5=`pkg-config Qt5Core --variable=prefix`
1522 TOOLQT5BIN=`pkg-config Qt5Core --variable=host_bins`
1523 if test_compile "$LIBQT5 $LIBPTHREAD $FLGQT5" qt5 qt5 nofatal; then
1524 test_execute_path "`strip_L "$LIBQT5"`" nofatal && foundqt5=3 # pkg-config
1525 fi
1526 fi
1527 else
1528 log_failure "pkg-config not found"
1529 fail
1530 fi
1531 fi
1532 if [ -z "$foundqt5" ]; then
1533 # Do it the old way (e.g. user has specified QT5DIR):
1534 for q in $QT5DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v5.*; do
1535 echo "(Qt5 from '$q')" >> $LOG
1536 INCQT5="$q/include $q/include/QtCore"
1537 FLGQT5="-DQT_SHARED"
1538 I_INCQT5=`prefix_I "$INCQT5"`
1539 LIBQT5="-L$q/lib -lQt5CoreVBox"
1540 TOOLQT5="$q"
1541 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1542 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1543 foundqt5=2 # internal
1544 break;
1545 fi
1546 LIBQT5="-L$q/lib -lQt5Core"
1547 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1548 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1549 foundqt5=1 # no pkg-config, Qt directory
1550 break;
1551 fi
1552 done
1553 fi
1554 fi
1555 if [ -n "$foundqt5" ]; then
1556 # We decided which version of Qt to use, now enforce the version requirement:
1557 cat > $ODIR.tmp_src.cc << EOF
1558#include <cstdio>
1559#include <QtGlobal>
1560extern "C" int main(void)
1561{
1562 printf("found version %s", QT_VERSION_STR);
1563EOF
1564 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1565 cat >> $ODIR.tmp_src.cc << EOF
1566 printf(", OK.\n");
1567 return 0;
1568#else
1569EOF
1570echo " printf(\", expected version $QT5MAJ.$QT5MIN or higher\\\\n\");" >> $ODIR.tmp_src.cc
1571 cat >> $ODIR.tmp_src.cc << EOF
1572 return 1;
1573#endif
1574}
1575EOF
1576 [ -n "$INCQT5" ] && I_INCQT5=`prefix_I "$INCQT5"`
1577 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal; then
1578 if test_execute_path "`strip_L "$LIBQT5"`"; then
1579 if [ "$OS" = "darwin" ]; then
1580 # Successful build & run the test application so add the necessary
1581 # params to AutoConfig.kmk:
1582 cnf_append "PATH_SDK_QT5_INC" "$PATH_SDK_QT5/Frameworks"
1583 cnf_append "PATH_SDK_QT5_LIB" "$PATH_SDK_QT5/Frameworks"
1584 cnf_append "PATH_SDK_QT5" "$PATH_SDK_QT5/Frameworks"
1585 # Check for the moc tool in the Qt directory found & some standard
1586 # directories.
1587 for q in $PATH_SDK_QT5 /usr /Developer/Tools/Qt; do
1588 if which_wrapper "$q/bin/moc" > /dev/null; then
1589 cnf_append "PATH_TOOL_QT5_BIN" "$q/bin"
1590 fi
1591 done
1592 else
1593 # Strip .../QtCore as we add components ourself:
1594 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1595 # store only the first path, remove all other paths
1596 # most likely pkg-config gave us -I/usr/include/qt5 -I/usr/include/qt5/QtCore
1597 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1598 cnf_append "VBOX_PATH_QT_LIB" "`strip_L "$LIBQT5"`"
1599 cnf_append "PATH_SDK_QT5_INC" "$INCQT5"
1600 # This is not quite right since the qt libpath does not have to be first...
1601 cnf_append "PATH_SDK_QT5_LIB" '$'"(firstword `strip_L "$LIBQT5"`)"
1602 if [ "$foundqt5" = "2" ]; then
1603 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1604 fi
1605 if [ "$foundqt5" != "3" ]; then
1606 TOOLQT5BIN="$TOOLQT5/bin"
1607 fi
1608 test_header "Qt5 devtools"
1609 # Try it with a suffix, some platforms use that
1610 if which_wrapper "$TOOLQT5BIN/moc-qt5" > /dev/null; then
1611 QT5BINSUFF="-qt5"
1612 else
1613 QT5BINSUFF=""
1614 fi
1615 moc_ver=`$TOOLQT5BIN/moc$QT5BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1616 if [ $? -ne 0 ]; then
1617 log_failure "moc$QT5BINSUFF not working"
1618 fail
1619 else
1620 log_success "found version $moc_ver"
1621 cnf_append "VBOX_PATH_QT" "$TOOLQT5"
1622 cnf_append "PATH_SDK_QT5" "$TOOLQT5"
1623 cnf_append "PATH_TOOL_QT5_BIN" "$TOOLQT5BIN"
1624 [ -n "$QT5BINSUFF" ] && cnf_append "TOOL_QT5_BIN_SUFF" "$QT5BINSUFF"
1625 fi
1626 fi
1627 fi
1628 else
1629 log_failure "qt5 not working"
1630 fail
1631 fi
1632 else
1633 log_failure "qt5 not found"
1634 fail
1635 fi
1636}
1637
1638
1639#
1640# Check for libvpx
1641#
1642check_vpx()
1643{
1644 if [ -z "$BUILD_LIBVPX" ]; then
1645 test_header libvpx
1646 if which_wrapper pkg-config > /dev/null; then
1647 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1648 if [ $? -eq 0 ]; then
1649 FLGVPX=`pkg-config vpx --cflags`
1650 INCVPX=`strip_I "$FLGVPX"`
1651 LIBVPX=`pkg-config vpx --libs`
1652 fi
1653 cat > $ODIR.tmp_src.cc << EOF
1654#include <cstdio>
1655#include <vpx/vpx_codec.h>
1656extern "C" int main(void)
1657{
1658 int version = vpx_codec_version();
1659 int verMajor = VPX_VERSION_MAJOR(version);
1660 int verMinor = VPX_VERSION_MINOR(version);
1661 int verPatch = VPX_VERSION_PATCH(version);
1662 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1663 if ( verMajor == 1 && verMinor >= 0
1664 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1665 {
1666 printf(", OK.\n");
1667 return 0;
1668 }
1669 else
1670 {
1671 printf(", expected version 0.9.5 or higher\n");
1672 return 1;
1673 }
1674}
1675EOF
1676 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1677 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1678 if test_execute; then
1679 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1680 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1681 fi
1682 fi
1683 fi
1684 fi
1685}
1686
1687
1688#
1689# Check whether static libstdc++ is installed. This library is required
1690# for the Linux guest additions.
1691#
1692check_staticlibstdcxx()
1693{
1694 test_header "static stc++ library"
1695 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1696 cat > $ODIR.tmp_src.cc << EOF
1697#include <string>
1698
1699extern "C" int main(void)
1700{
1701 std::string s = "test";
1702 return 0;
1703}
1704EOF
1705 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1706 log_success "found"
1707 fi
1708}
1709
1710
1711#
1712# Check for Linux sources
1713#
1714check_linux()
1715{
1716 test_header "Linux kernel sources"
1717 cat > $ODIR.tmp_src.c << EOF
1718#include <linux/version.h>
1719int printf(const char *format, ...);
1720int main(void)
1721{
1722 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1723 (LINUX_VERSION_CODE % 65536) / 256,
1724 LINUX_VERSION_CODE % 256);
1725#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1726 printf(", OK.\n");
1727 return 0;
1728#else
1729 printf(", expected version 2.4.0 or higher\n");
1730 return 1;
1731#endif
1732}
1733EOF
1734 echo "compiling the following source file:" >> $LOG
1735 cat $ODIR.tmp_src.c >> $LOG
1736 echo "using the following command line:" >> $LOG
1737 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1738 "-I$LINUX/include/generated/uapi" >> $LOG
1739 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1740 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1741 if [ $? -ne 0 ]; then
1742 echo
1743 echo " Linux kernel headers not found at $LINUX"
1744 echo " Check the file $LOG for detailed error information."
1745 fail
1746 else
1747 if test_execute; then
1748 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1749 fi
1750 fi
1751}
1752
1753#
1754# Check for kchmviewer, needed to display the online help
1755# (unused as we ship kchmviewer)
1756#
1757check_kchmviewer()
1758{
1759 test_header kchmviewer
1760 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1761 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1762 if [ $? -ne 0 ]; then
1763 log_failure "kchmviewer not working"
1764 fail
1765 else
1766 log_success "found version $kchmviewer_ver"
1767 fi
1768 fi
1769}
1770
1771
1772#
1773# Check for the kBuild tools, we don't support GNU make
1774#
1775check_kbuild()
1776{
1777 test_header kBuild
1778 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1779 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1780 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1781 echo "export PATH_KBUILD" >> $ENV
1782 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1783 echo "export PATH_DEVTOOLS" >> $ENV
1784 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1785 echo "export PATH_KBUILD_BIN" >> $ENV
1786 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1787 if [ "$OS" = "solaris" ]; then
1788 # Because of sh being non-default shell in Solaris we need to export PATH again when
1789 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1790 echo "PATH=\"$ORGPATH\"" >> $ENV
1791 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1792 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1793 else
1794 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1795 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1796 fi
1797 echo "export PATH" >> $ENV
1798 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1799 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1800 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1801 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1802 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1803 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1804 echo "export PATH_KBUILD" >> $ENV
1805 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1806 echo "export PATH_DEVTOOLS" >> $ENV
1807 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1808 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1809 echo "export PATH_KBUILD_BIN" >> $ENV
1810 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1811 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1812 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1813 echo "export PATH" >> $ENV
1814 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1815 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1816 elif check_avail "kmk" KBUILDDIR really; then
1817 # check for installed kBuild
1818 KBUILD_SED="`which_wrapper kmk_sed`"
1819 else
1820 fail
1821 fi
1822 log_success "found"
1823}
1824
1825
1826#
1827# Check for compiler.h
1828# Some Linux distributions include "compiler.h" in their libc linux
1829# headers package, some don't. Most don't need it, building might (!)
1830# not succeed on openSUSE without it.
1831#
1832# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1833#
1834check_compiler_h()
1835{
1836 test_header compiler.h
1837 if test ! -f "/usr/include/linux/compiler.h"; then
1838 log_success "compiler.h not found"
1839 else
1840 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1841 log_success "compiler.h found"
1842 fi
1843}
1844
1845#
1846# Check for libcap.
1847# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1848# sockets for doing ICMP requests.
1849#
1850check_libcap()
1851{
1852 test_header "libcap library"
1853 cat > $ODIR.tmp_src.cc << EOF
1854#include <cstdio>
1855#include <sys/types.h>
1856#include <linux/types.h>
1857#include <sys/capability.h>
1858
1859extern "C" int main(void)
1860{
1861 char buf[1024];
1862 cap_t caps = cap_get_proc();
1863 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1864 return 0;
1865}
1866EOF
1867 if test_compile $LIBCAP libcap libcap; then
1868 if test_execute; then
1869 log_success "found"
1870 fi
1871 fi
1872}
1873
1874#
1875# Check if we are able to build 32-bit applications (needed for the guest additions)
1876#
1877check_32bit()
1878{
1879 test_header "32-bit support"
1880 cat > $ODIR.tmp_src.c << EOF
1881#include <stdint.h>
1882int main(void)
1883{
1884 return 0;
1885}
1886EOF
1887 echo "compiling the following source file:" >> $LOG
1888 cat $ODIR.tmp_src.c >> $LOG
1889 echo "using the following command line:" >> $LOG
1890 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1891 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1892 if [ $? -ne 0 ]; then
1893 echo
1894 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1895 echo " Check the file $LOG for detailed error information."
1896 fail
1897 else
1898 echo "executing the binary" >> $LOG
1899 $ODIR.tmp_out 2> $ODIR.test_execute.log
1900 rc=$?
1901 cat $ODIR.test_execute.log >> $LOG
1902 if [ $rc -ne 0 ]; then
1903 echo
1904 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1905 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1906 fail
1907 return 1
1908 fi
1909 fi
1910 log_success ""
1911}
1912
1913
1914#
1915# Check for Python
1916#
1917check_python()
1918{
1919 test_header "Python support"
1920
1921 # On darwin this is a on/off decision only
1922 if [ "$OS" = "darwin" ]; then
1923 echo "enabled"
1924 cnf_append "VBOX_WITH_PYTHON" "1"
1925 return
1926 fi
1927
1928 cat > $ODIR.tmp_src.cc << EOF
1929#include <cstdio>
1930#include <Python.h>
1931extern "C" int main(void)
1932{
1933 Py_Initialize();
1934 printf("found version %s", PY_VERSION);
1935#if PY_VERSION_HEX >= 0x02060000
1936 printf(", OK.\n");
1937 return 0;
1938#else
1939 printf(", expected version 2.6 or higher\n");
1940 return 1;
1941#endif
1942}
1943EOF
1944 found=
1945 SUPPYTHONLIBS="python2.7 python2.6 python3.1 python3.2 python3.3 python3.4 python3.4m python3.5 python3.5m"
1946 for p in $PYTHONDIR; do
1947 for d in $SUPPYTHONLIBS; do
1948 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
1949 echo "compiling the following source file:" >> $LOG
1950 cat $ODIR.tmp_src.cc >> $LOG
1951 echo "using the following command line:" >> $LOG
1952 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1953 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1954 if [ $? -eq 0 ]; then
1955 found=1
1956 break
1957 fi
1958 done
1959 if [ -n "$found" ]; then break; fi
1960 done
1961 if [ -n "$found" ]; then break; fi
1962 done
1963 if [ -n "$found" ]; then
1964 if test_execute; then
1965 cnf_append "VBOX_WITH_PYTHON" "1"
1966 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1967 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1968 else
1969 log_failure "Python not working"
1970 fail
1971 fi
1972 else
1973 log_failure "Python not found"
1974 fail
1975 fi
1976}
1977
1978
1979#
1980# Check for Java
1981#
1982check_java()
1983{
1984 test_header "Java support"
1985 log_success
1986}
1987
1988
1989#
1990# Setup wine
1991#
1992setup_wine()
1993{
1994 test_header "Wine support"
1995 if ! which_wrapper wine > /dev/null; then
1996 echo " wine binary not found"
1997 fail
1998 fi
1999 if ! which_wrapper wine > /dev/null; then
2000 echo " wine not found"
2001 fail
2002 fi
2003 wine_version="`wine --version`"
2004 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2005 "0")
2006 if ! which_wrapper wineprefixcreate > /dev/null; then
2007 echo " wineprefixcreate not found"
2008 fail
2009 fi
2010 ;;
2011 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2012 esac
2013 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2014 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2015 echo "export WINEPREFIX" >> $ENV
2016 rm -rf $WINEPREFIX
2017 mkdir -p $WINEPREFIX
2018 touch $WINEPREFIX/.no_prelaunch_window_flag
2019 if ! wineprefixcreate -q > /dev/null 2>&1; then
2020 echo " wineprefixcreate failed"
2021 fail
2022 fi
2023 tmp=.tmp.wine.reg
2024 rm -f $tmp
2025 echo 'REGEDIT4' > $tmp
2026 echo '' >> $tmp
2027 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2028 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2029 echo '' >> $tmp
2030 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2031 echo '"itss"="native"' >> $tmp
2032 echo '' >> $tmp
2033 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2034 echo '"itss"="native"' >> $tmp
2035 echo '' >> $tmp
2036 if ! wine regedit $tmp > /dev/null 2>&1; then
2037 rm -f $tmp
2038 echo " failed to load registry changes (path)."
2039 fail
2040 fi
2041 rm -f $tmp
2042 log_success "found"
2043}
2044
2045
2046#
2047# Check for gSOAP.
2048#
2049check_gsoap()
2050{
2051 test_header "GSOAP compiler"
2052 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2053 if which_wrapper pkg-config > /dev/null; then
2054 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2055 if [ $? -eq 0 ]; then
2056 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2057 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2058 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2059 GSOAP_IMPORT="$GSOAP/include/gsoap"
2060 fi
2061 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2062 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2063 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2064 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2065 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2066 else
2067 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2068 fi
2069 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2070 gsoap_version=`pkg-config gsoapssl++ --modversion`
2071 log_success "found version $gsoap_version"
2072 return
2073 fi
2074 fi
2075 fi
2076 if [ -z "$GSOAP" ]; then
2077 GSOAP="/usr"
2078 fi
2079 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2080 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2081 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2082 # TODO: Check for libgsoap++.a/so
2083
2084 if [ -z "$GSOAP_IMPORT" ]; then
2085 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2086 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2087 GSOAP_IMPORT="$GSOAP/include/gsoap"
2088 fi
2089 fi
2090 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2091 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2092 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2093 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2094 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2095 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2096 else
2097 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2098 fi
2099 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2100 log_success "found"
2101 else
2102 log_failure "stlvector.h not found -- disabling webservice"
2103 cnf_append "VBOX_WITH_WEBSERVICES" ""
2104 fi
2105 else
2106 log_failure "stdsoap2.h not found -- disabling webservice"
2107 cnf_append "VBOX_WITH_WEBSERVICES" ""
2108 fi
2109 else
2110 log_failure "wsdl2h not found -- disabling webservice"
2111 cnf_append "VBOX_WITH_WEBSERVICES" ""
2112 fi
2113 else
2114 log_failure "soapcpp2 not found -- disabling webservice"
2115 cnf_append "VBOX_WITH_WEBSERVICES" ""
2116 fi
2117}
2118
2119
2120#
2121# Check Xcode path
2122#
2123check_xcode_sdk_path()
2124{
2125 # Check if WITH_XCODE_DIR is set.
2126 if [ -z "$WITH_XCODE_DIR" ]; then
2127 echo "Please specify --with-xcode-dir option."
2128 return 0
2129 fi
2130
2131 # Check if specified path exists and is a directory.
2132 if [ -d "$1" ]; then
2133 return 1
2134 else
2135 echo "Xcode path [$1] not found."
2136 return 0
2137 fi
2138}
2139
2140#
2141# Determines the Darwin version.
2142# @todo This should really check the Xcode/SDK version.
2143#
2144check_darwinversion()
2145{
2146 test_header "Darwin version"
2147 darwin_ver=`uname -r`
2148 case "$darwin_ver" in
2149 17\.*)
2150 check_xcode_sdk_path "$WITH_XCODE_DIR"
2151 [ $? -eq 1 ] || fail
2152 darwin_ver="10.13" # High Sierra
2153 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2154 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2155 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2156 ;;
2157 16\.*)
2158 check_xcode_sdk_path "$WITH_XCODE_DIR"
2159 [ $? -eq 1 ] || fail
2160 darwin_ver="10.12" # Sierra
2161 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2162 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2163 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2164 ;;
2165 15\.*)
2166 check_xcode_sdk_path "$WITH_XCODE_DIR"
2167 [ $? -eq 1 ] || fail
2168 darwin_ver="10.11" # El Capitan
2169 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2170 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2171 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2172 ;;
2173 14\.*)
2174 check_xcode_sdk_path "$WITH_XCODE_DIR"
2175 [ $? -eq 1 ] || fail
2176 darwin_ver="10.10" # Yosemite
2177 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2178 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2179 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2180 ;;
2181 13\.*)
2182 check_xcode_sdk_path "$WITH_XCODE_DIR"
2183 [ $? -eq 1 ] || fail
2184 darwin_ver="10.9" # Mavericks
2185 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2186 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2187 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2188 ;;
2189 12\.*)
2190 darwin_ver="10.8" # Mountain Lion
2191 if [ ! -z "$WITH_XCODE_DIR" ]; then
2192 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2193 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2194 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2195 else
2196 sdk=/Developer/SDKs/MacOSX10.6.sdk
2197 fi
2198 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2199 ;;
2200 11\.*)
2201 darwin_ver="10.7" # Lion
2202 sdk=/Developer/SDKs/MacOSX10.6.sdk
2203 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2204 ;;
2205 10\.*)
2206 darwin_ver="10.6" # Snow Leopard
2207 if [ "$BUILD_MACHINE" = "x86" ]; then
2208 sdk=/Developer/SDKs/MacOSX10.5.sdk
2209 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2210 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2211 else
2212 sdk=/Developer/SDKs/MacOSX10.6.sdk
2213 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2214 fi
2215# test "$CC" = "gcc" && CC="gcc-4.0"
2216# test "$CXX" = "g++" && CXX="g++-4.0"
2217 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2218 ;;
2219 9\.*)
2220 darwin_ver="10.5" # Leopard
2221 sdk=/Developer/SDKs/MacOSX10.5.sdk
2222 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2223# test "$CC" = "gcc" && CC="gcc-4.0"
2224# test "$CXX" = "g++" && CXX="g++-4.0"
2225 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2226 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2227 ;;
2228 8\.*)
2229 darwin_ver="10.4" # Tiger
2230 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2231 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2232# test "$CC" = "gcc" && CC="gcc-4.0"
2233# test "$CXX" = "g++" && CXX="g++-4.0"
2234 cnf_append "VBOX_WITH_COCOA_QT" ""
2235 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2236 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2237 ;;
2238 *)
2239 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2240 fail
2241 darwin_ver="unknown"
2242 ;;
2243 esac
2244 log_success "found version $darwin_ver (SDK: $sdk)"
2245}
2246
2247
2248check_makeself()
2249{
2250 test_header "makeself"
2251 if check_avail "$MAKESELF" makeself; then
2252 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2253 if [ $? -ne 0 ]; then
2254 log_failure "makeself not working"
2255 fail
2256 else
2257 log_success "found version $makeself_ver"
2258 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2259 fi
2260 fi
2261}
2262
2263
2264#
2265# Show help
2266#
2267show_help()
2268{
2269cat << EOF
2270Usage: ./configure [OPTIONS]...
2271
2272Configuration:
2273 -h, --help display this help and exit
2274 --nofatal don't abort on errors
2275EOF
2276[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2277[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2278[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2279[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2280[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2281[ $WITH_QT5 -eq 1 ] && echo " --disable-qt disable Qt detection"
2282[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2283[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2284[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2285[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2286[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2287[ $WITH_QT5 -eq 0 ] && echo " --enable-qt5 enable Qt5 detection"
2288[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2289[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2290[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2291[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2292[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2293[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2294cat << EOF
2295 --disable-udptunnel disable UDP tunnel networking
2296 --disable-devmapper disable device mapper library access
2297 --disable-hardening don't be strict about /dev/vboxdrv access
2298 --build-libxml2 build libxml2 from sources
2299EOF
2300[ $OSE -eq 0 ] && cat << EOF
2301 --build-libssl build openssl from sources
2302 --build-libcurl build libcurl from sources
2303 --build-libvpx build libvpx from sources
2304EOF
2305[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2306cat << EOF
2307 --only-additions only build the Guest Additions
2308
2309Paths:
2310 --with-gcc=PATH location of the gcc compiler [$CC]
2311 --with-g++=PATH location of the g++ compiler [$CXX]
2312 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2313 --with-iasl=PATH location of the iasl compiler [$IASL]
2314 --with-makeself=PATH location of makeself [$MAKESELF]
2315EOF
2316[ "$OS" = "darwin" ] && echo " --with-xcode-dir=DIR custom path to Xcode root directory; it is assumed that Xcode"
2317[ "$OS" = "darwin" ] && echo " contains OS X 10.6 SDK (required for Mountain Lion and newer hosts"
2318[ "$OS" = "darwin" ] && echo " only, ignored for the rest)"
2319[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2320[ $WITH_QT5 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt headers/libraries [pkgconfig]"
2321[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2322[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2323[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2324cat << EOF
2325 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2326 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2327 --out-path=PATH the folder to which configuration and build output
2328 should go
2329
2330Build type:
2331 -d, --build-debug build with debugging symbols and assertions
2332 --build-profile build with profiling support
2333 --build-headless build headless (without any GUI frontend)
2334EOF
2335 exit 0
2336}
2337
2338
2339#
2340# The body.
2341#
2342
2343# test if we are OSE
2344if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2345 OSE=0
2346 # Set this as a reminder to print a log message once we know the path of the
2347 # log file
2348 NOT_OSE=1
2349fi
2350
2351# Change OS specific defaults; must be before all other stuff
2352if [ "$OS" = "darwin" ]; then
2353 WITH_SDL=0
2354 WITH_SDL_TTF=0
2355 WITH_X11=0
2356 WITH_ALSA=0
2357 WITH_PULSE=0
2358 WITH_DBUS=0
2359 WITH_KMODS=0
2360 BUILD_LIBXML2=1
2361 BUILD_LIBVPX=1
2362 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2363 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2364 WITH_XCODE_DIR=""
2365elif [ "$OS" = "haiku" ]; then
2366 #WITH_SDL=0
2367 WITH_SDL_TTF=0
2368 WITH_X11=0
2369 WITH_ALSA=0
2370 WITH_PULSE=0
2371 WITH_DBUS=0
2372 WITH_KMODS=0
2373 WITH_LIBIDL=0
2374 WITH_XPCOM=0
2375 BUILD_LIBXSLT=1
2376 BUILD_LIBXML2=1
2377 WITH_LIBVPX=0
2378 # it is part of libroot, which is linked by default,
2379 # but the script wants something
2380 LIBPTHREAD="-lroot"
2381 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2382 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2383elif [ "$OS" = "solaris" ]; then
2384 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2385fi
2386
2387# scan command line options
2388for option in "$@"; do
2389 case "$option" in
2390 --help|-help|-h)
2391 show_help
2392 ;;
2393 --nofatal)
2394 nofatal=1
2395 ;;
2396 --env-only)
2397 ENV_ONLY=1
2398 ;;
2399 --with-gcc=*)
2400 CC=`echo $option | cut -d'=' -f2`
2401 ;;
2402 --with-g++=*)
2403 CXX=`echo $option | cut -d'=' -f2`
2404 ;;
2405 --with-kbuild=*)
2406 KBUILDDIR=`echo $option | cut -d'=' -f2`
2407 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2408 echo "Error: KBUILDDIR contains invalid characters!"
2409 exit 1
2410 fi
2411 ;;
2412 --with-qt-dir=*)
2413 [ $WITH_QT5 -eq 1 ] && QT5DIR=`echo $option | cut -d'=' -f2`
2414 [ $WITH_QT5 -eq 1 ] && QT5DIR_PKGCONFIG=0
2415 ;;
2416 --with-qt5-minor=*)
2417 QT5MIN=`echo $option | cut -d'=' -f2`
2418 ;;
2419 --with-qt5-major=*)
2420 QT5MAJ=`echo $option | cut -d'=' -f2`
2421 ;;
2422 --with-openssl-dir=*)
2423 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2424 INCCRYPTO="-I${OPENSSLDIR}/include"
2425 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2426 ;;
2427 --with-ow-dir=*)
2428 WATCOM=`echo $option | cut -d'=' -f2`
2429 ;;
2430 --with-gsoap-dir=*)
2431 GSOAP=`echo $option | cut -d'=' -f2`
2432 ;;
2433 --with-gsoap-import=*)
2434 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2435 ;;
2436 --with-iasl=*)
2437 IASL=`echo $option | cut -d'=' -f2`
2438 ;;
2439 --with-xcode-dir=*)
2440 WITH_XCODE_DIR=`echo $option | cut -d'=' -f2`
2441 echo $option
2442 ;;
2443 --with-linux=*)
2444 LINUX=`echo $option | cut -d'=' -f2`
2445 ;;
2446 --with-makeself=*)
2447 MAKESELF=`echo $option | cut -d'=' -f2`
2448 ;;
2449 --target-arch=*)
2450 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2451 ;;
2452 --disable-xpcom)
2453 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2454 ;;
2455 --disable-python)
2456 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2457 ;;
2458 --disable-java)
2459 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2460 ;;
2461 --disable-vmmraw)
2462 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2463 ;;
2464 --disable-sdl-ttf)
2465 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2466 ;;
2467 --disable-qt)
2468 [ $WITH_QT5 -eq 1 ] && WITH_QT5=0
2469 ;;
2470 --enable-qt5)
2471 [ $WITH_QT5 -eq 0 ] && WITH_QT5=1
2472 ;;
2473 --passive-mesa)
2474 PASSIVE_MESA=1
2475 ;;
2476 --disable-alsa)
2477 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2478 ;;
2479 --disable-pulse)
2480 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2481 ;;
2482 --enable-pulse)
2483 WITH_PULSE=2
2484 ;;
2485 --disable-dbus)
2486 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2487 ;;
2488 --disable-kmods)
2489 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2490 ;;
2491 --disable-opengl)
2492 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2493 ;;
2494 --enable-webservice)
2495 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2496 ;;
2497 --enable-vnc)
2498 WITH_VNC=1
2499 ;;
2500 --disable-hardening)
2501 WITH_HARDENING=0
2502 ;;
2503 --disable-extpack)
2504 WITH_EXTPACK=0
2505 ;;
2506 --disable-docs)
2507 WITH_DOCS=0
2508 ;;
2509 --enable-hardening)
2510 WITH_HARDENING=2
2511 ;;
2512 --disable-udptunnel)
2513 WITH_UDPTUNNEL=0
2514 ;;
2515 --enable-vde)
2516 WITH_VDE=1
2517 ;;
2518 --disable-devmapper)
2519 WITH_DEVMAPPER=0
2520 ;;
2521 --disable-libvpx)
2522 WITH_LIBVPX=0
2523 ;;
2524 --disable-sdl)
2525 WITH_SDL=0
2526 ;;
2527 --build-debug|-d)
2528 BUILD_TYPE=debug
2529 ;;
2530 --build-profile)
2531 BUILD_TYPE=profile
2532 ;;
2533 --build-libxml2)
2534 BUILD_LIBXML2=1
2535 ;;
2536 --build-libssl)
2537 BUILD_LIBSSL=1
2538 ;;
2539 --build-libcurl)
2540 BUILD_LIBCURL=1
2541 ;;
2542 --build-libvpx)
2543 BUILD_LIBVPX=1
2544 ;;
2545 --build-headless)
2546 HEADLESS=1
2547 WITH_SDL=0
2548 WITH_SDL_TTF=0
2549 WITH_X11=0
2550 WITH_OPENGL=0
2551 WITH_QT5=0
2552 ;;
2553 --ose)
2554 OSE=2
2555 ;;
2556 --odir=*)
2557 ODIR="`echo $option | cut -d'=' -f2`/"
2558 ODIR_OVERRIDE=1
2559 ;;
2560 --out-path=*)
2561 out_path="`echo $option | cut -d'=' -f2`/"
2562 if [ -d $out_path ]; then
2563 saved_path="`pwd`"
2564 cd $out_path
2565 OUT_PATH="`pwd`"
2566 cd $saved_path
2567 OUT_PATH_OVERRIDE=1
2568 if [ $ODIR_OVERRIDE -eq 0 ]; then
2569 # This variable has not *yet* been overridden. That can still happen.
2570 ODIR=$OUT_PATH/
2571 fi
2572 else
2573 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2574 exit 1
2575 fi
2576 ;;
2577 --setup-wine)
2578 [ "$OS" != "darwin" ] && SETUP_WINE=1
2579 ;;
2580 --only-additions)
2581 ONLY_ADDITIONS=1
2582 ;;
2583 *)
2584 echo
2585 echo "Unrecognized option \"$option\""
2586 echo
2587 show_help
2588 ;;
2589 esac
2590done
2591
2592LOG="$ODIR$LOG"
2593ENV="$ODIR$ENV"
2594CNF="$ODIR$CNF"
2595
2596# initialize output files
2597cat > $LOG << EOF
2598# Log file generated by
2599#
2600# '$0 $*'
2601#
2602
2603EOF
2604cat > $CNF << EOF
2605# -*- Makefile -*-
2606#
2607# automatically generated by
2608#
2609# '$0 $*'
2610#
2611# It will be completely overwritten if configure is executed again.
2612#
2613
2614EOF
2615cat > $ENV << EOF
2616#!/bin/bash
2617#
2618# automatically generated by
2619#
2620# '$0 $*'
2621#
2622# It will be completely overwritten if configure is executed again.
2623# Make sure you source this file once before you start to build VBox.
2624#
2625
2626EOF
2627
2628# Print log warning about OSE if necessary
2629if [ -n "$NOT_OSE" ]; then
2630 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2631 echo >> $LOG
2632fi
2633
2634
2635if [ "$BUILD_TYPE" = "debug" ]; then
2636 echo "Creating DEBUG build!" >> $LOG
2637elif [ "$BUILD_TYPE" = "profile" ]; then
2638 echo "Creating PROFILE build!" >> $LOG
2639fi
2640
2641# first determine our environment
2642check_environment
2643check_kbuild
2644
2645[ -n "$ENV_ONLY" ] && exit 0
2646
2647# append the tools directory to the default search path
2648echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2649export PATH
2650
2651# if we will be writing to a different out directory then set this up now
2652if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2653 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2654 echo "export AUTOCFG" >> $ENV
2655 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2656 echo "export LOCALCFG" >> $ENV
2657 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2658 echo "export PATH_OUT_BASE" >> $ENV
2659fi
2660
2661# don't bother people with -Werror
2662cnf_append "VBOX_GCC_WERR" "\$(NO_SUCH_VARIABLE)"
2663
2664# some things are not available in for OSE
2665if [ $OSE -ge 1 ]; then
2666 cnf_append "VBOX_OSE" "1"
2667 cnf_append "VBOX_WITH_VALIDATIONKIT" ""
2668 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2669
2670 if [ "$OS" = "linux" ]; then
2671 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2672 else
2673 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2674 fi
2675 echo >> $CNF
2676fi
2677
2678# extpack
2679if [ $ONLY_ADDITIONS -eq 1 ]; then
2680 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2681elif [ $OSE -eq 0 ]; then
2682 if [ $WITH_EXTPACK -eq 1 ]; then
2683 BUILD_LIBSSL=1
2684 else
2685 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2686 fi
2687fi
2688
2689# headless
2690if [ -n "$HEADLESS" ]; then
2691 cnf_append "VBOX_HEADLESS" "1"
2692fi
2693
2694# emit disable directives corresponding to any --disable-xxx options.
2695if [ $WITH_OPENGL -eq 0 ]; then
2696 cnf_append "VBOX_WITH_CROGL" ""
2697 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2698 cnf_append "VBOX_GUI_USE_QGL" ""
2699fi
2700[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2701[ $WITH_QT5 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2702[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2703[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2704[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2705[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2706[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2707[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2708[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2709if [ $WITH_LIBVPX -eq 0 ]; then
2710 cnf_append "VBOX_WITH_LIBVPX" ""
2711 cnf_append "VBOX_WITH_VIDEOREC" ""
2712fi
2713
2714# Darwin-specific
2715if [ "$OS" = "darwin" ]; then
2716 check_darwinversion
2717fi
2718# the tools
2719check_gcc
2720if [ $ONLY_ADDITIONS -eq 0 ]; then
2721 check_open_watcom
2722 [ "$OS" != "darwin" ] && check_iasl
2723 # don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2724 # [ "$OS" != "darwin" ] && check_yasm
2725 [ "$OS" != "darwin" ] && check_xsltproc
2726fi
2727
2728# the libraries
2729if [ $ONLY_ADDITIONS -eq 0 ]; then
2730 [ "$OS" != "darwin" ] && check_pthread
2731 check_libxml2
2732 [ $WITH_LIBIDL -eq 1 ] && check_libidl
2733 check_ssl
2734 check_curl
2735 [ $WITH_LIBVPX -eq 1 ] && check_vpx
2736 [ "$OS" != "darwin" ] && check_z
2737 [ "$OS" != "darwin" ] && check_png
2738 [ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2739 if [ $WITH_SDL -eq 1 ]; then
2740 check_sdl
2741 else
2742 cnf_append "VBOX_WITH_VBOXSDL" ""
2743 fi
2744 [ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2745 [ $WITH_X11 -eq 1 ] && check_x
2746 # TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2747 # TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2748 [ $WITH_X11 -eq 1 ] && check_xcursor
2749 [ $WITH_X11 -eq 1 ] && check_xinerama
2750 [ $WITH_X11 -eq 1 ] && check_xrandr
2751 [ $WITH_OPENGL -eq 1 ] && check_opengl
2752 [ $WITH_QT5 -eq 1 ] && check_qt5
2753 [ $WITH_PYTHON -eq 1 ] && check_python
2754 [ $WITH_JAVA -eq 1 ] && check_java
2755
2756 # PulseAudio
2757 if [ "$OS" = "linux" -o "$OS" = "freebsd" -o "$OS" = "netbsd" ]; then
2758 if [ $WITH_PULSE -eq 1 ]; then
2759 check_pulse
2760 elif [ $WITH_PULSE -eq 0 ]; then
2761 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
2762 fi
2763 fi
2764fi
2765
2766# Linux-specific
2767if [ "$OS" = "linux" ]; then
2768 # don't check for the static libstdc++ in the PUEL version as we build the
2769 # additions at a dedicated box
2770 [ $OSE -ge 1 ] && check_staticlibstdcxx
2771 if [ $WITH_KMODS -eq 1 ]; then
2772 check_linux
2773 else
2774 cnf_append "VBOX_LINUX_SRC" ""
2775 cnf_append "VBOX_WITHOUT_LINUX_TEST_BUILDS" "1"
2776 fi
2777 if [ $ONLY_ADDITIONS -eq 0 ]; then
2778 if [ $WITH_ALSA -eq 1 ]; then
2779 check_alsa
2780 else
2781 cnf_append "VBOX_WITH_AUDIO_ALSA" ""
2782 fi
2783 if [ $WITH_DBUS -eq 0 ]; then
2784 cnf_append "VBOX_WITH_DBUS" ""
2785 fi
2786 if [ $WITH_DEVMAPPER -eq 1 ]; then
2787 check_libdevmapper
2788 else
2789 cnf_append "VBOX_WITH_DEVMAPPER" ""
2790 fi
2791 check_libcap
2792 fi
2793 check_compiler_h
2794 [ $ONLY_ADDITIONS -eq 0 -a "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2795 # tools/common/makeself*
2796 [ $OSE -ge 1 ] && check_makeself
2797fi
2798
2799[ -n "$SETUP_WINE" ] && setup_wine
2800
2801if [ $ONLY_ADDITIONS -eq 0 -a $WITH_GSOAP -eq 1 ]; then
2802 check_gsoap
2803else
2804 if [ $OSE -ge 1 ]; then
2805 cnf_append "VBOX_WITH_WEBSERVICES" ""
2806 fi
2807fi
2808
2809# UDPTUNNEL
2810if [ $ONLY_ADDITIONS -eq 0 -a $WITH_UDPTUNNEL -eq 0 ]; then
2811 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2812fi
2813
2814# VDE
2815if [ $ONLY_ADDITIONS -eq 0 -a "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2816 if [ $WITH_VDE -eq 1 ]; then
2817 cnf_append "VBOX_WITH_VDE" "1"
2818 fi
2819fi
2820
2821# DOCS
2822if [ $ONLY_ADDITIONS -eq 1 -o $WITH_DOCS -eq 0 ]; then
2823 cnf_append "VBOX_WITH_DOCS" ""
2824 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2825fi
2826
2827# VNC server support
2828if [ $ONLY_ADDITIONS -eq 0 -a $OSE -ge 1 ]; then
2829 if [ $WITH_VNC = 1 ]; then
2830 check_vncserver
2831 else
2832 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2833 fi
2834fi
2835
2836if [ $ONLY_ADDITIONS -eq 1 ]; then
2837 cnf_append "VBOX_ONLY_ADDITIONS" "1"
2838fi
2839
2840# success!
2841echo
2842echo "Successfully generated '$CNF' and '$ENV'."
2843echo "Source '$ENV' once before you start to build VBox:"
2844echo ""
2845echo " source $ENV"
2846echo " kmk"
2847echo ""
2848if [ "$OS" = "linux" ]; then
2849 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2850 vbox_out_path=$OUT_PATH
2851 else
2852 vbox_out_path=./out
2853 fi
2854 echo "To compile the kernel modules, do:"
2855 echo ""
2856 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2857 echo " make"
2858 echo ""
2859fi
2860if [ $ONLY_ADDITIONS -eq 1 ]; then
2861 echo ""
2862 echo " Tree configured to build only the Guest Additions"
2863 echo ""
2864elif [ $WITH_HARDENING -gt 0 ]; then
2865 echo ""
2866 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2867 echo " Hardening is enabled which means that the VBox binaries will not run from"
2868 echo " the binary directory. The binaries have to be installed suid root and some"
2869 echo " more prerequisites have to be fulfilled which is normally done by installing"
2870 echo " the final package. For development, the hardening feature can be disabled"
2871 echo " by specifying the --disable-hardening parameter. Please never disable that"
2872 echo " feature for the final distribution!"
2873 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2874 echo ""
2875else
2876 echo ""
2877 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2878 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2879 echo " disabled hardening!"
2880 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2881 echo ""
2882fi
2883echo "Enjoy!"
2884cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette